add options to disable specific checksums for Indexes
[ntk/apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
3# we all like colorful messages
4CERROR="\e[1;31m" # red
5CWARNING="\e[1;33m" # yellow
6CMSG="\e[1;32m" # green
7CINFO="\e[1;96m" # light blue
8CDEBUG="\e[1;94m" # blue
9CNORMAL="\e[0;39m" # default system console color
10CDONE="\e[1;32m" # green
11CPASS="\e[1;32m" # green
12CFAIL="\e[1;31m" # red
13CCMD="\e[1;35m" # pink
14
15msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
18msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25msgtest() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
29
30# enable / disable Debugging
fc89263e
DK
31MSGLEVEL=${MSGLEVEL:-3}
32if [ $MSGLEVEL -le 0 ]; then
33 msgdie() { true; }
34fi
35if [ $MSGLEVEL -le 1 ]; then
36 msgwarn() { true; }
37 msgnwarn() { true; }
38fi
39if [ $MSGLEVEL -le 2 ]; then
40 msgmsg() { true; }
41 msgnmsg() { true; }
39cc8228
DK
42 msgtest() { true; }
43 msgpass() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
44 msgskip() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
45 msgfail() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
fc89263e
DK
46fi
47if [ $MSGLEVEL -le 3 ]; then
48 msginfo() { true; }
49 msgninfo() { true; }
50fi
51if [ $MSGLEVEL -le 4 ]; then
52 msgdebug() { true; }
53 msgndebug() { true; }
54fi
55msgdone() {
56 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
57 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
58 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
59 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
60 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
61 true;
62 else
63 echo "${CDONE}DONE${CNORMAL}" >&2;
64 fi
65}
8d876415
DK
66
67runapt() {
68 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
7d0627b6
DK
69 if [ -f ./aptconfig.conf ]; then
70 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
4b2a4ab8
MV
71 elif [ -f ../aptconfig.conf ]; then
72 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
7d0627b6
DK
73 else
74 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
75 fi
8d876415
DK
76}
77aptconfig() { runapt apt-config $*; }
78aptcache() { runapt apt-cache $*; }
79aptget() { runapt apt-get $*; }
80aptftparchive() { runapt apt-ftparchive $*; }
1f8b2599 81aptkey() { runapt apt-key $*; }
ec7f904e 82aptmark() { runapt apt-mark $*; }
158fda31
DK
83dpkg() {
84 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
85}
b6b5a542
DK
86aptitude() {
87 if [ -f ./aptconfig.conf ]; then
88 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
89 elif [ -f ../aptconfig.conf ]; then
90 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
91 else
92 LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
93 fi
94}
8d876415 95
b720d0bd
DK
96addtrap() {
97 CURRENTTRAP="$CURRENTTRAP $1"
98 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
99}
8d876415
DK
100
101setupenvironment() {
75954ae2 102 TMPWORKINGDIRECTORY=$(mktemp -d)
8f8169ac 103 local TESTDIR=$(readlink -f $(dirname $0))
3cbbda3c 104 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
8f8169ac 105 BUILDDIRECTORY="${TESTDIR}/../../build/bin"
8d876415
DK
106 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
107 local OLDWORKINGDIRECTORY=$(pwd)
b720d0bd 108 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
8d876415 109 cd $TMPWORKINGDIRECTORY
cd725954 110 mkdir rootdir aptarchive keys
8d876415 111 cd rootdir
b29c3712
DK
112 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
113 mkdir -p var/cache var/lib var/log
cffea9af 114 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
2c6baa5a 115 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
8f8169ac
DK
116 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
117 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
118 else
119 touch var/lib/dpkg/status
120 fi
cd725954 121 touch var/lib/dpkg/available
8d876415
DK
122 mkdir -p usr/lib/apt
123 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
124 cd ..
2c6baa5a 125 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
8f8169ac
DK
126 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
127 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 128 fi
4a4ea26c
AM
129 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
130 if [ -f "${TESTDIR}/${SOURCESSFILE}" ]; then
131 cp "${TESTDIR}/${SOURCESSFILE}" aptarchive/Sources
8f8169ac 132 fi
cd725954
DK
133 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
134 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
cffea9af 135 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
94eb3bee 136 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
8d876415
DK
137 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
138 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
f425d4d5 139 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
cffea9af
DK
140 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
141 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
142 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
143 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
144 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
145 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
2c085486 146 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
8d876415
DK
147 export LC_ALL=C
148 msgdone "info"
149}
150
151configarchitecture() {
152 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
153 echo "APT::Architecture \"$1\";" > $CONFFILE
154 shift
155 while [ -n "$1" ]; do
156 echo "APT::Architectures:: \"$1\";" >> $CONFFILE
157 shift
158 done
159}
160
75954ae2 161setupsimplenativepackage() {
ce9864a8
DK
162 local NAME="$1"
163 local ARCH="$2"
164 local VERSION="$3"
165 local RELEASE="${4:-unstable}"
166 local DEPENDENCIES="$5"
167 local DESCRIPTION="$6"
b7899b00
DK
168 local SECTION="${7:-others}"
169 local DISTSECTION
170 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
171 DISTSECTION="main"
172 else
173 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
174 fi
ce9864a8
DK
175 local BUILDDIR=incoming/${NAME}-${VERSION}
176 mkdir -p ${BUILDDIR}/debian/source
177 cd ${BUILDDIR}
178 echo "* most suckless software product ever" > FEATURES
b7899b00
DK
179 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
180 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
ce9864a8
DK
181
182 * Initial release
183
b7899b00
DK
184 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
185 test -e debian/control || echo "Source: $NAME
186Section: $SECTION
ce9864a8
DK
187Priority: optional
188Maintainer: Joe Sixpack <joe@example.org>
189Build-Depends: debhelper (>= 7)
190Standards-Version: 3.9.1
191
875bcb36
DK
192Package: $NAME" > debian/control
193 if [ "$ARCH" = 'all' ]; then
194 echo "Architecture: all" >> debian/control
195 else
196 echo "Architecture: any" >> debian/control
197 fi
ce9864a8
DK
198 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
199 if [ -z "$DESCRIPTION" ]; then
200 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
201 If you find such a package installed on your system,
202 YOU did something horribly wrong! They are autogenerated
203 und used only by testcases for APT and surf no other propose…" >> debian/control
204 else
205 echo "Description: $DESCRIPTION" >> debian/control
206 fi
b7899b00
DK
207 test -e debian/compat || echo "7" > debian/compat
208 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
ce9864a8 209 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
75954ae2
DK
210 cd - > /dev/null
211}
212
213buildsimplenativepackage() {
214 local NAME="$1"
215 local ARCH="$2"
216 local VERSION="$3"
217 local RELEASE="${4:-unstable}"
218 local DEPENDENCIES="$5"
219 local DESCRIPTION="$6"
220 local SECTION="${7:-others}"
221 local DISTSECTION
222 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
223 DISTSECTION="main"
224 else
225 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
226 fi
5a635ee4 227 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
b761356f 228
18331adf 229 msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}… "
b761356f
DK
230 mkdir -p $BUILDDIR/debian/source
231 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
232 echo "#!/bin/sh
233echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
234
235 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
236 echo "$NAME ($VERSION) $RELEASE; urgency=low
237
238 * Initial release
239
240 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
241 echo "Source: $NAME
242Section: $SECTION
243Priority: optional
244Maintainer: Joe Sixpack <joe@example.org>
245Standards-Version: 3.9.1
246
875bcb36
DK
247Package: $NAME" > ${BUILDDIR}/debian/control
248 if [ "$ARCH" = 'all' ]; then
249 echo "Architecture: all" >> ${BUILDDIR}/debian/control
250 else
251 echo "Architecture: any" >> ${BUILDDIR}/debian/control
252 fi
b761356f
DK
253 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> ${BUILDDIR}/debian/control
254 if [ -z "$DESCRIPTION" ]; then
255 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
256 If you find such a package installed on your system,
257 YOU did something horribly wrong! They are autogenerated
258 und used only by testcases for APT and surf no other propose…" >> ${BUILDDIR}/debian/control
259 else
260 echo "Description: $DESCRIPTION" >> ${BUILDIR}/debian/control
261 fi
262 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
263 local SRCS="$( (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
264
265 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
266 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
267 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
875bcb36 268 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$ARCH)
b761356f
DK
269 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
270
6a910c9d 271 dpkg-deb --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. 2> /dev/null > /dev/null
5a635ee4 272 echo "pool/${NAME}_${VERSION}_${ARCH}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
b761356f 273 for SRC in $SRCS; do
5a635ee4 274 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
b761356f 275 done
13845042
DK
276 mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
277 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
278 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
5a635ee4 279 rm -rf "${BUILDDIR}"
b761356f 280 msgdone "info"
75954ae2
DK
281}
282
283buildpackage() {
284 local BUILDDIR=$1
285 local RELEASE=$2
286 local SECTION=$3
287 msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
288 cd $BUILDDIR
289 if [ "$ARCH" = "all" ]; then
290 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
291 fi
b7899b00
DK
292 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
293 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
5ed56f93 294 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 295 cd - > /dev/null
b7899b00 296 for PKG in $PKGS; do
75954ae2 297 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
b7899b00
DK
298 done
299 for SRC in $SRCS; do
75954ae2 300 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
b7899b00 301 done
cffea9af 302 msgdone "info"
ce9864a8
DK
303}
304
305buildaptarchive() {
ce9864a8
DK
306 if [ -d incoming ]; then
307 buildaptarchivefromincoming $*
308 else
309 buildaptarchivefromfiles $*
310 fi
311}
312
313createaptftparchiveconfig() {
314 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
158fda31
DK
315 if [ -z "$ARCHS" ]; then
316 # the pool is empty, so we will operate on faked packages - let us use the configured archs
317 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
318 fi
ce9864a8
DK
319 echo -n 'Dir {
320 ArchiveDir "' >> ftparchive.conf
321 echo -n $(readlink -f .) >> ftparchive.conf
322 echo -n '";
323 CacheDir "' >> ftparchive.conf
324 echo -n $(readlink -f ..) >> ftparchive.conf
325 echo -n '";
b7899b00
DK
326 FileListDir "' >> ftparchive.conf
327 echo -n $(readlink -f pool/) >> ftparchive.conf
328 echo -n '";
329};
330Default {
331 Packages::Compress ". gzip bzip2 lzma";
332 Sources::Compress ". gzip bzip2 lzma";
333 Contents::Compress ". gzip bzip2 lzma";
18331adf
DK
334 Translation::Compress ". gzip bzip2 lzma";
335 LongDescription "false";
ce9864a8
DK
336};
337TreeDefault {
338 Directory "pool/";
339 SrcDirectory "pool/";
340};
341APT {
342 FTPArchive {
343 Release {
344 Origin "joesixpack";
345 Label "apttestcases";
346 Suite "unstable";
347 Description "repository with dummy packages";
348 Architectures "' >> ftparchive.conf
349 echo -n "$ARCHS" >> ftparchive.conf
350 echo 'source";
351 };
352 };
353};' >> ftparchive.conf
b7899b00
DK
354 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
355 echo -n 'tree "dists/' >> ftparchive.conf
356 echo -n "$DIST" >> ftparchive.conf
357 echo -n '" {
ce9864a8
DK
358 Architectures "' >> ftparchive.conf
359 echo -n "$ARCHS" >> ftparchive.conf
b7899b00
DK
360 echo -n 'source";
361 FileList "' >> ftparchive.conf
362 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
363 echo -n '";
364 SourceFileList "' >> ftparchive.conf
365 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
366 echo -n '";
367 Sections "' >> ftparchive.conf
368 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
369 echo '";
ce9864a8 370};' >> ftparchive.conf
b7899b00 371 done
ce9864a8
DK
372}
373
374buildaptftparchivedirectorystructure() {
b7899b00
DK
375 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
376 for DIST in $DISTS; do
377 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
378 for SECTION in $SECTIONS; do
379 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
380 for ARCH in $ARCHS; do
381 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
382 done
383 mkdir -p dists/${DIST}/${SECTION}/source
384 mkdir -p dists/${DIST}/${SECTION}/i18n
385 done
ce9864a8 386 done
ce9864a8
DK
387}
388
9b78cda6
DK
389insertpackage() {
390 local RELEASE="$1"
391 local NAME="$2"
392 local ARCH="$3"
393 local VERSION="$4"
394 local DEPENDENCIES="$5"
395 local ARCHS="$ARCH"
396 if [ "$ARCHS" = "all" ]; then
397 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
398 fi
399 for BUILDARCH in $ARCHS; do
400 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
401 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
402 touch aptarchive/dists/${RELEASE}/main/source/Sources
403 local FILE="${PPATH}/Packages"
404 echo "Package: $NAME
405Priority: optional
406Section: other
2c085486 407Installed-Size: 42
9b78cda6
DK
408Maintainer: Joe Sixpack <joe@example.org>
409Architecture: $ARCH
2c085486
DK
410Version: $VERSION
411Filename: pool/main/${NAME}/${NAME}_${VERSION}_${ARCH}.deb" >> $FILE
9b78cda6
DK
412 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
413 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
414 If you find such a package installed on your system,
415 YOU did something horribly wrong! They are autogenerated
416 und used only by testcases for APT and surf no other propose…
417" >> $FILE
418 done
419}
420
ce9864a8 421buildaptarchivefromincoming() {
3cbbda3c 422 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
ce9864a8
DK
423 cd aptarchive
424 [ -e pool ] || ln -s ../incoming pool
425 [ -e ftparchive.conf ] || createaptftparchiveconfig
426 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 427 msgninfo "\tGenerate Packages, Sources and Contents files… "
ce9864a8 428 aptftparchive -qq generate ftparchive.conf
ce9864a8
DK
429 cd - > /dev/null
430 msgdone "info"
9b78cda6 431 generatereleasefiles
ce9864a8
DK
432}
433
434buildaptarchivefromfiles() {
3cbbda3c 435 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
9b78cda6
DK
436 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
437 msgninfo "\t${line} file… "
438 cat ${line} | gzip > ${line}.gz
439 cat ${line} | bzip2 > ${line}.bz2
440 cat ${line} | lzma > ${line}.lzma
8d876415 441 msgdone "info"
9b78cda6
DK
442 done
443 generatereleasefiles
444}
445
446generatereleasefiles() {
447 msgninfo "\tGenerate Release files… "
fe0f7911 448 local DATE="${1:-now}"
9b78cda6 449 if [ -e aptarchive/dists ]; then
18331adf
DK
450 for dir in $(find ./aptarchive/dists -mindepth 3 -maxdepth 3 -type d -name 'i18n'); do
451 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Patterns::='Translation-*' > $dir/Index
452 done
9b78cda6 453 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
35faae11 454 local CODENAME="$(echo "$dir" | cut -d'/' -f 4)"
2c085486
DK
455 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Suite="${CODENAME}" -o APT::FTPArchive::Release::Codename="${CODENAME}" | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
456 if [ "$CODENAME" = "experimental" -o "$CODENAME" = "experimental2" ]; then
35faae11
DK
457 sed -i '/^Date: / a\
458NotAutomatic: yes' $dir/Release
459 fi
9b78cda6
DK
460 done
461 else
462 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
8d876415 463 fi
fe0f7911
DK
464 if [ "$DATE" != "now" ]; then
465 for release in $(find ./aptarchive -name 'Release'); do
466 touch -d "$1" $release
467 done
8d876415 468 fi
b7899b00 469 msgdone "info"
8d876415
DK
470}
471
b7899b00
DK
472setupdistsaptarchive() {
473 local APTARCHIVE=$(readlink -f ./aptarchive)
474 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
475 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
476 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
477 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
478 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
479 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
480 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
481 msgdone "info"
482 done
483}
484
485setupflataptarchive() {
ce9864a8 486 local APTARCHIVE=$(readlink -f ./aptarchive)
8d876415
DK
487 if [ -f ${APTARCHIVE}/Packages ]; then
488 msgninfo "\tadd deb sources.list line… "
489 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
490 msgdone "info"
491 else
492 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
493 fi
494 if [ -f ${APTARCHIVE}/Sources ]; then
495 msgninfo "\tadd deb-src sources.list line… "
496 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
497 msgdone "info"
498 else
499 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
500 fi
b7899b00
DK
501}
502
503setupaptarchive() {
504 buildaptarchive
505 if [ -e aptarchive/dists ]; then
506 setupdistsaptarchive
507 else
508 setupflataptarchive
509 fi
f213b6ea 510 signreleasefiles
cd725954 511 msgninfo "\tSync APT's cache with the archive… "
8d876415 512 aptget update -qq
cd725954 513 msgdone "info"
8d876415
DK
514}
515
f213b6ea
DK
516signreleasefiles() {
517 local SIGNER="${1:-Joe Sixpack}"
518 msgninfo "\tSign archive with $SIGNER key… "
519 local SECKEYS=""
520 for KEY in $(find keys/ -name '*.sec'); do
521 SECKEYS="$SECKEYS --secret-keyring $KEY"
522 done
523 local PUBKEYS=""
524 for KEY in $(find keys/ -name '*.pub'); do
525 PUBKEYS="$PUBKEYS --keyring $KEY"
526 done
527 for RELEASE in $(find aptarchive/ -name Release); do
528 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
fe0f7911 529 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
f213b6ea
DK
530 done
531 msgdone "info"
532}
533
534changetowebserver() {
535 if which weborf > /dev/null; then
536 weborf -xb aptarchive/ 2>&1 > /dev/null &
b720d0bd 537 addtrap "kill $!;"
f213b6ea
DK
538 local APTARCHIVE="file://$(readlink -f ./aptarchive)"
539 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
540 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
541 done
542 return 0
543 fi
544 return 1
545}
546
547checkdiff() {
8d876415
DK
548 local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
549 if [ -n "$DIFFTEXT" ]; then
550 echo
551 echo "$DIFFTEXT"
552 return 1
553 else
554 return 0
555 fi
556}
557
75954ae2
DK
558testfileequal() {
559 local FILE="$1"
560 shift
561 msgtest "Test for correctness of file" "$FILE"
562 if [ -z "$*" ]; then
f213b6ea 563 echo -n "" | checkdiff $FILE - && msgpass || msgfail
75954ae2 564 else
f213b6ea 565 echo "$*" | checkdiff $FILE - && msgpass || msgfail
75954ae2
DK
566 fi
567}
568
8d876415
DK
569testequal() {
570 local COMPAREFILE=$(mktemp)
b720d0bd 571 addtrap "rm $COMPAREFILE;"
8d876415
DK
572 echo "$1" > $COMPAREFILE
573 shift
574 msgtest "Test for equality of" "$*"
f213b6ea 575 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
576}
577
685625bd
DK
578testequalor2() {
579 local COMPAREFILE1=$(mktemp)
580 local COMPAREFILE2=$(mktemp)
581 local COMPAREAGAINST=$(mktemp)
b720d0bd 582 addtrap "rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
685625bd
DK
583 echo "$1" > $COMPAREFILE1
584 echo "$2" > $COMPAREFILE2
585 shift 2
586 msgtest "Test for equality OR of" "$*"
587 $* 2>&1 1> $COMPAREAGAINST
f213b6ea
DK
588 (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
589 checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
590 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
591 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
685625bd
DK
592 msgfail )
593}
594
8d876415 595testshowvirtual() {
edc0ef10 596 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
597 local PACKAGE="$1"
598 shift
599 while [ -n "$1" ]; do
600 VIRTUAL="${VIRTUAL}
edc0ef10 601N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
602 PACKAGE="${PACKAGE} $1"
603 shift
604 done
605 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
606 VIRTUAL="${VIRTUAL}
4bec02c2 607N: No packages found"
8d876415 608 local COMPAREFILE=$(mktemp)
b720d0bd 609 addtrap "rm $COMPAREFILE;"
8d876415
DK
610 local ARCH=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
611 eval `apt-config shell ARCH APT::Architecture`
612 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
e8379ba3 613 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
614}
615
616testnopackage() {
617 msgtest "Test for non-existent packages" "apt-cache show $*"
618 local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
619 if [ -n "$SHOWPKG" ]; then
620 echo
621 echo "$SHOWPKG"
622 msgfail
623 return 1
624 fi
625 msgpass
626}
01a6e24c
DK
627
628testdpkginstalled() {
629 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
87bc1c45
DK
630 local PKGS="$(dpkg -l $* | grep '^i' | wc -l)"
631 if [ "$PKGS" != $# ]; then
01a6e24c
DK
632 echo $PKGS
633 dpkg -l $* | grep '^[a-z]'
634 msgfail
635 return 1
636 fi
637 msgpass
638}
639
5cf733e1
DK
640testdpkgnotinstalled() {
641 msgtest "Test for correctly not-installed package(s) with" "dpkg -l $*"
87bc1c45 642 local PKGS="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
01a6e24c
DK
643 if [ "$PKGS" != 0 ]; then
644 echo
645 dpkg -l $* | grep '^[a-z]'
646 msgfail
647 return 1
648 fi
649 msgpass
650}
ec7f904e
DK
651
652testmarkedauto() {
653 local COMPAREFILE=$(mktemp)
654 addtrap "rm $COMPAREFILE;"
655 if [ -n "$1" ]; then
656 msgtest 'Test for correctly marked as auto-installed' "$*"
657 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
658 else
659 msgtest 'Test for correctly marked as auto-installed' 'no package'
660 echo > $COMPAREFILE
661 fi
662 aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
663}